/* Allocation and deallocation of the key is handled by this module, and the
 * key is therefore always copied.  */
struct _btnode {
	char *key;
	struct _btnode *l, *r;  /* binary tree pointers */
};

typedef struct _btnode btnode;

btnode **rbsearch (btnode **ppnode, char *key);
btnode *newbtnode (char *key);
void delbtnode (btnode *victim);

#define FAILURE 0
#define SUCCESS 1

int insert (btnode **tree, char *key);
