#include <stdio.h>
#include <stdlib.h>
#include "bintree.h"

int
main() {
	btnode *tree = NULL;
	#define INBUFSIZ 4096
	char inbuf[INBUFSIZ];
	int innum;
	btnode **nnode;

	while (1) {
		printf("? ");
		fflush(stdout);
		
		if (NULL == fgets(inbuf, INBUFSIZ, stdin)) break;
		innum = atoi(inbuf);
		printf("Searching for %d\n", innum);
		nnode = rbsearch(&tree, innum);
		if (*nnode == NULL) {
			printf("%d not found -- inserting\n", innum);
			*nnode = newbtnode(innum);
			if (*nnode == NULL) {
				printf("Insertion failed!\n");
			}
		} else {
			printf("%d found\n", innum);
		}
	}
	return 0;
}
